from __future__ import print_function
import numpy as np
import time
from kalmanfilter import KalmanFilter 

def nextStep(KF, newVal):
    KF.predict()
    KF.update(newVal)
    return KF.x

def inc(d, i):
    a = 0.5
    time.sleep(a)
    i = i + a
    print("d: ", d[0,0], " / i: ", i, flush=True)
    return i

if __name__=="__main__":
    dt = 1
    # x: current car state x = (distance, velocity)^T. Distance means the distance to it's prev platoon member and velocity its relative speed.
    x = np.array([[0,0]]).T
    # P: covariance matrix
    P = np.array([[10,0],[0,10]])
    
    # F: dynamic model
    F = np.array([[1,dt],[0,1]])
    # Q: process error
    Q = np.array([[1,0],[0,1]])
    # H: measure matrix, references the distance
    H = np.array([[1,0]])
    # R: measurement error
    R = np.array([[5]])
    
    KF = KalmanFilter(x, P, F, Q, H, R, dt)

    i = 0
    d = np.array([[0.0]])
    print(1)
    while i < 10:
        i = inc(d, i)
        print(nextStep(KF, d))
    print(2)
    while d[0,0] < 9:
        # from IPython import embed; embed()
        d[0,0] += 0.5
        i = inc(d, i)
        print(nextStep(KF, d))
    print(3)
    while i < 40:
        i = inc(d, i)
        print(nextStep(KF, d))
    print(4)
    while d[0,0] > 1:
        d[0,0] -= 0.5
        i = inc(d, i)
        print(nextStep(KF, d))
    print(5)
    while i < 70:
        i = inc(d, i)
        print(nextStep(KF, d))
    print(6)
    while d[0,0] > 0:
        d[0,0] -= 0.25
        i = inc(d, i)
        print(nextStep(KF, d))
    print(7)
    while i < 100:
        i = inc(d, i)
        print(nextStep(KF, d))
